﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;

namespace ItemsCheckedDemo
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Page
    {
        public MainWindow()
        {
            InitializeComponent();

            List<DataClass> members = (from p in Data.GetData()
                                       select new DataClass(p)).ToList();

            base.DataContext = new DataClassAll(members);
        }
    }

    public class Data
    {
        public static Data[] GetData()
        {
            return new Data[]
            {
                new Data("Jane", "Smith", 24),
                new Data("Mike", "Wheeler", 45),
                new Data("Ned", "Ableton", 67),
                new Data("Patrick", "McCort", 12),
                new Data("Ravi", "Patel", 28),
                new Data("Wallace", "Barrington", 42),
                new Data("Jane", "Smith", 23),
                new Data("Mike", "Wheeler", 45),
                new Data("Ned", "Ableton", 67),
                new Data("Patrick", "McCort", 12),
                new Data("Ravi", "Patel", 28),
                new Data("Jane", "Smith", 24),
                new Data("Mike", "Wheeler", 45),
                new Data("Ned", "Ableton", 67),
                new Data("Patrick", "McCort", 12),
                new Data("Ravi", "Patel", 28),
                new Data("Wallace", "Barrington", 42),
                new Data("Jane", "Smith", 23),
                new Data("Mike", "Wheeler", 45),
                new Data("Ned", "Ableton", 67),
                new Data("Patrick", "McCort", 12),
                new Data("Ravi", "Patel", 28),
                new Data("Jane", "Smith", 24),
                new Data("Mike", "Wheeler", 45),
                new Data("Ned", "Ableton", 67),
                new Data("Patrick", "McCort", 12),
                new Data("Ravi", "Patel", 28),
                new Data("Wallace", "Barrington", 42),
                new Data("Jane", "Smith", 23),
                new Data("Mike", "Wheeler", 45),
                new Data("Ned", "Ableton", 67),
                new Data("Patrick", "McCort", 12),
                new Data("Ravi", "Patel", 28),
                new Data("Jane", "Smith", 24),
                new Data("Mike", "Wheeler", 45),
                new Data("Ned", "Ableton", 67),
                new Data("Patrick", "McCort", 12),
                new Data("Ravi", "Patel", 28),
                new Data("Wallace", "Barrington", 42),
                new Data("Jane", "Smith", 23),
                new Data("Mike", "Wheeler", 45),
                new Data("Ned", "Ableton", 67),
                new Data("Patrick", "McCort", 12),
                new Data("Ravi", "Patel", 28),
                new Data("Jane", "Smith", 24),
                new Data("Mike", "Wheeler", 45),
                new Data("Ned", "Ableton", 67),
                new Data("Patrick", "McCort", 12),
                new Data("Ravi", "Patel", 28),
                new Data("Wallace", "Barrington", 42),
                new Data("Jane", "Smith", 23),
                new Data("Mike", "Wheeler", 45),
                new Data("Ned", "Ableton", 67),
                new Data("Patrick", "McCort", 12),
                new Data("Ravi", "Patel", 28)
            };
        }
        public Data(string fname, string lname, int age)
        {
            this.FirstName = fname;
            this.LastName = lname;
            this.Age = age;
        }

        public int Age { get; private set; }
        public string FirstName { get; private set; }
        public string LastName { get; private set; }

    }
    public class DataClass : INotifyPropertyChanged
    {
        readonly Data data;
        private bool isChecked;

        public DataClass(Data mydata)
        {
            data = mydata;
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public string FirstName { get { return data.FirstName; } }
        public string LastName { get { return data.LastName; } }
        public int Age { get { return data.Age; } }

        public bool IsChecked
        {
            get
            {
                return isChecked;
            }
            set
            {
                if (value != isChecked)
                {
                    isChecked = value;
                    this.OnPropertyChanged("IsChecked");
                }
            }
        }

        protected void OnPropertyChanged(PropertyChangedEventArgs e)
        {
            var handler = this.PropertyChanged;
            if (handler != null)
            {
                handler(this, e);
            }
        }

        /// <summary>
        /// Event handler for PropertyChanged events
        /// </summary>
        /// <param name="propertyName">property name</param>
        protected void OnPropertyChanged(string propertyName)
        {
            this.OnPropertyChanged(new PropertyChangedEventArgs(propertyName));
        }
    }

    public class DataClassAll : INotifyPropertyChanged
    {

        public DataClassAll(List<DataClass> members)
        {
            this.Members = members;

            foreach (DataClass member in members)
                member.PropertyChanged += (sender, e) =>
                {
                    // Raising PropertyChanged for the AllMembersAreChecked
                    // property causes the data binding system to query its
                    // getter for the new value.
                    if (e.PropertyName == "IsChecked")
                        this.OnPropertyChanged("AllMembersAreChecked");
                };
        }
        public List<DataClass> Members { get; private set; }

        public bool? AllMembersAreChecked
        {
            get
            {
                // Determine if all members have the same 
                // value for the IsChecked property.
                bool? value = null;
                for (int i = 0; i < this.Members.Count; ++i)
                {
                    if (i == 0)
                    {
                        value = this.Members[0].IsChecked;
                    }
                    else if (value != this.Members[i].IsChecked)
                    {
                        value = null;
                        break;
                    }
                }

                return value;
            }
            set
            {
                if (value == null)
                    return;

                foreach (DataClass member in this.Members)
                    member.IsChecked = value.Value;
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        void OnPropertyChanged(string prop)
        {
            if (this.PropertyChanged != null)
                this.PropertyChanged(this, new PropertyChangedEventArgs(prop));
        }
    }
}
